#include <stdio.h>
#include <stdlib.h>
#include "Map.h"
#include "Robot.h"

extern RobotGangClass * MyRobot;

void MapClass::CreateMap(int MapSizeXParam, int MapSizeYParam) {
  int MapSize = MapSizeXParam * MapSizeYParam;
  MapSizeX = MapSizeXParam;
  MapSizeY = MapSizeYParam;
  Map = (char *) malloc(MapSize);
  if (Map == NULL)
    exit(1);
}

void MapClass::BuildRow(int Row, char * RowData) {
  char * RowPtr = Map + (Row - 1) * MapSizeX;
  while ((*RowData) != 0) 
    *(RowPtr++) = *RowData++;
}

void MapClass::Print(void) {
  int i, j;
  printf("           +"); 
  for(i=1; i<= MapSizeX; i++) 
    printf("-"); 
  printf("+\n");
  for (i=MapSizeY; i>=1; i--) {
    printf ("Row %5i: |", i);
    for (j=1; j<= MapSizeX; j++)
      printf("%c", *(Map + (j-1) + ((i-1)*MapSizeX)));
    printf ("|\n");
  }
  printf("           +"); for(i=1; i<= MapSizeX; i++) printf("-"); printf("+\n");
}

int MapClass::TileType(int XPos, int YPos) {
  if ((XPos>MapSizeX) || (YPos>MapSizeY) ||(XPos<1) || (YPos<1)) {
    return 1;
  }
  char * PosPtr = Map + (XPos -1) + ((YPos -1) * MapSizeX);
  switch (*PosPtr) {
  case '~' :
    return 2;
  case '#' :
    return 1;
  case '@' :
    return 3;
  default:
    return 0;
  }
}

int MapClass::FreeTile(int XPos, int YPos) {
  if ((XPos < 1) || (XPos > MapSizeX) || (YPos < 1) || (YPos > MapSizeY))
    return 0;
  char * PosPtr = Map + (XPos -1) + ((YPos -1) * MapSizeX);
  if ((*PosPtr=='.')||(*PosPtr=='@'))
    return 1;
  else
    return 0;
}

int MapClass::MapCost(int X, int Y) {
  if (MyRobot->RobotCount > 1){
    if ((TileType(X+1, Y) == 0) && (TileType(X-1, Y) == 2)) 
      return 3;
    if ((TileType(X-1, Y) == 0) && (TileType(X+1, Y) == 2)) 
      return 3;
    if ((TileType(X, Y+1) == 0) && (TileType(X, Y-1) == 2)) 
      return 3;
    if ((TileType(X, Y-1) == 0) && (TileType(X, Y+1) == 2)) 
      return 3;
  }
  if (TileType(X, Y) == 3)
    return 0;
  return 1;
}

void MapClass::FindBase(int * X, int * Y) {
  // return location of random base
  //printf("Searching for base \n");
  int NumBase=0;
  int SelectedBase;
  int base[100][2];
  int i, j;
  for (i=1; i<=MapSizeX; i++) {
    for (j=1; j<=MapSizeY; j++) {
      if (TileType(i, j) == 3) {
	base[NumBase][0] = i;
	base[NumBase][1] = j;
	NumBase++;
	//printf("Base found at X: %i  Y:%i\n", i, j);
      }
      if (NumBase == 100)
	break;
    }
    if (NumBase == 100)
      break;
  }
  SelectedBase = rand() % NumBase;
  *X = base[SelectedBase][0];
  *Y = base[SelectedBase][1];
}
  
