#ifndef MAP_H
#define MAP_H
class MapClass {

public:
  void CreateMap(int MapSizeX, int MapSizeY);
  void BuildRow(int Row, char * RowData);
  
  void FindBase(int * X, int * Y);

  // 0 = open tile
  // 1 = wall
  // 2 = water
  int TileType(int XPos, int YPos);

  // 1 = tile free
  // 0 = tile impassable
  int FreeTile(int XPos, int YPos);

  // make robot hydrophobic
  // by making cost of tiles next to water
  // more expensive to traverse.
  int MapCost(int XPos, int YPos);

  
  int GetMapSizeX(void);
  int GetMapSizeY(void);

  void Print(void);

private:
  int MapSizeX;
  int MapSizeY;
  char * Map;
};

inline int MapClass::GetMapSizeX(void) {return MapSizeX;};

inline int MapClass::GetMapSizeY(void) {return MapSizeY;};

#endif
