#include "Map.h"
#include "Robot.h"
#include <sys/types.h>
#include <sys/socket.h>
#include <netinet/in.h>
#include <arpa/inet.h>
#include <unistd.h>
#include <netdb.h>
#include <string.h>
#include <stdio.h>

MapClass MyMap;
RobotGangClass * MyRobot;
PackageClass PackageList;



int main(int argc, char ** argv, char ** env) {

  // process Command line
  if (argc != 3) {
    printf("invalid number of parameters: %i\n", argc);
    printf("   program host port\n");
    exit(1);
  }

  char HostName[100];
  unsigned Port;
  sscanf (argv[1], "%s", HostName);
  sscanf(argv[2], "%u", &Port);

  // translate hostname to IP address
  struct hostent * HostInfo;
  HostInfo = gethostbyname(HostName);

  int SocketFD;
  SocketFD = socket(AF_INET, SOCK_STREAM, 0);
  
  struct sockaddr_in SocketAddress;
  SocketAddress.sin_family = AF_INET;
  SocketAddress.sin_port = htons(Port);
  SocketAddress.sin_addr = *(struct in_addr *) *HostInfo-> h_addr_list;
  // inet_addr(HostInfo.h_addr);
  
  int result = connect(SocketFD, (struct sockaddr *) &SocketAddress, 
		       sizeof(SocketAddress));

  if (result == -1) {
    printf("Socket connection failed\n");
    exit (1);
  }

  // send player command
  write(SocketFD, "Player\n", 7);

  // get board
  char Buffer[10001];
  unsigned int MapWidth, MapHeight;

  FILE * SockStream;
  SockStream = fdopen(SocketFD, "r+");

  fgets(Buffer, 100, SockStream);
  sscanf(Buffer, "%u %u", &MapWidth, &MapHeight);

  MyMap.CreateMap(MapWidth, MapHeight);

  int i;
  //  char MapRow[10000];
  for (i=1; i<= (int) MapHeight; i++) {
    fgets(Buffer, MapWidth+10, SockStream);
    MyMap.BuildRow(i, Buffer);
  }
  
  //MyMap.Print();

  int PlayerID, WtAllowance, Credits;
  fgets(Buffer, 100, SockStream);
  sscanf(Buffer, "%u %u %u", &PlayerID, &WtAllowance, &Credits);
  RobotGangClass RobotGang;
  RobotGang.AddRobot(PlayerID, &MyMap);

  MyRobot = RobotGang.FindRobot(PlayerID);
  MyRobot->Robot->SetEnergy(Credits);
  MyRobot->Robot->SetMaxWeight(WtAllowance);
  
  system("clear");

  while (!feof(SockStream)) {
    printf("Processing Status\n");
    RobotGang.ProcessStatus(SockStream);
    printf("Getting Package list\n");
    MyRobot->Robot->ProcessPackages(SockStream);
    printf("Generating robot command\n");
    MyRobot->Robot->GenerateCommand(SockStream);
    MyRobot->Robot->Print();
    //usleep(50000);
  }

  printf ("End of file detected on socket \n");
  exit (0);

  //MyRobot->Print();

  exit (0);


}



